#ifndef TEXTURE_H
#define TEXTURE_H

#include <GL/glew.h>
#include <GLFW/glfw3.h>
#include <iostream>

class Texture
{
public:
    Texture();
    Texture(const Texture& orig);
    virtual ~Texture();
    
    bool load(const char* path);
    void bind();
    bool isLoaded();
private:
    bool load(const char* path, FILE* file);
    void initGL();
    
    bool loaded = false;
    
    unsigned int width = 0;
    unsigned int height = 0;
    unsigned int* data = nullptr;
    
    static GLuint boundTexture; 
    GLuint texture = 0;
};

#endif


